<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>ContactDetail</title>
</head>
<style>
    input {
        border: none;
        border-radius: 5px;
        display: flex;
        flex-wrap: wrap;
    }
</style>

<body onload="onPageLoading()">
    <div class="container jumbotron">

        <div class="row d-flex align-items-center">
            <div class="col-sm-8 text-center mx-auto">
                <div class="form-group text-center">
                    <h3 class="font-weight-bold">THÔNG TIN LIÊN HỆ CHI TIẾT</h3>
                </div>
                <div class="form-group d-flex justify-content-between align-items-center">
                    <label class="font-weight-bold ml-5" for="name">Name <b class="text-danger">(*)</b></label>
                    <input class="w-75 font-italic" type="text" style="height: 40px;" id="input-name">
                </div>
                <div class="form-group d-flex justify-content-between align-items-center">
                    <label class="font-weight-bold ml-5" for="input-email">Email <b class="text-danger">(*)</b></label>
                    <input class="w-75 font-italic" type="text" style="height: 40px;" id="input-email">
                </div>
                <div class="form-group d-flex justify-content-between align-items-center">
                    <label class="font-weight-bold ml-4" for="input-message">Message <b
                            class="text-danger">(*)</b></label>
                    <input class="w-75 font-italic" type="text" style="height: 100px;" name="" id="input-message">
                </div>
                <div class="form-group d-flex justify-content-between align-items-center">
                    <label class="font-weight-bold" for="input-date">Ngày liên hệ <b class="text-danger">(*)</b></label>
                    <input class="w-75 font-italic" type="text" style="height: 40px;" id="input-date">
                </div>
                <div class="form-group d-flex justify-content-end align-items-center">
                    <button class="btn btn-info" onclick="onBtnSaveDataClick()">Save data</button>
                </div>
            </div>
        </div>
    </div>

    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    var gContactDetailObj = {
        name: "",
        email: "",
        message: "",
        createDate: ""
    }

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // var vUrlString = ;
        var vUrl = new URL(window.location.href)
        var vId = vUrl.searchParams.get("id");
        const vAPI_URL = gBASE_URL + "/contacts/"
        var vXmlHttpContact = new XMLHttpRequest();
        vXmlHttpContact.open("GET", vAPI_URL + vId, true);
        vXmlHttpContact.send();
        vXmlHttpContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttpContact.responseText);
                displayContactInfoIntoFormContact(vXmlHttpContact)
            }else if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status != gREQUEST_STATUS_OK){
                window.location.href = "listContact.html"
            }
        }
    }
    function onBtnSaveDataClick() {
        //b1 đọc dữ liệu:
        truyXuatDuLieu(gContactDetailObj)
        //b2:Kiểm tra dữ liệu
        var vValidate = validateDuLieu(gContactDetailObj)
        if (vValidate) {
            //b3: gọi api update contact
            var vXmlHttpUpdateContact = new XMLHttpRequest();
            callApiToUpdateDataContact(gContactDetailObj, vXmlHttpUpdateContact)
            vXmlHttpUpdateContact.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpUpdateContact.responseText);
                    alert("Cập nhật liên hệ thành công!")
                    window.location.href = "listContact.html"
                }
            }

        }


    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //b1 đọc dữ liệu:

    function displayContactInfoIntoFormContact(paramXmlHttpObj) {
        var vContactDetailObj = JSON.parse(paramXmlHttpObj.responseText)
        var vInpName = document.getElementById("input-name");
        var vInpEmail = document.getElementById("input-email");
        var vInputMess = document.getElementById("input-message");
        var vInpDate = document.getElementById("input-date");

        vInpName.value = vContactDetailObj.name;
        vInpEmail.value = vContactDetailObj.email;
        vInputMess.value = vContactDetailObj.message;
        vInpDate.value = vContactDetailObj.createDate;
    }
    function truyXuatDuLieu(paramContactDetailObj) {
        var vInpName = document.getElementById("input-name");
        var vInpEmail = document.getElementById("input-email");
        var vInputMess = document.getElementById("input-message");
        var vInpDate = document.getElementById("input-date");

        paramContactDetailObj.name = vInpName.value.trim();
        paramContactDetailObj.email = vInpEmail.value.trim();
        paramContactDetailObj.message = vInputMess.value.trim();
        paramContactDetailObj.createDate = vInpDate.value.trim();
    }
    //b2:Kiểm tra dữ liệu
    function validateDuLieu(paramContactDetailObj) {
        if (paramContactDetailObj.name == "") {
            alert("Hãy nhập tên!")
            return false
        }
        if (paramContactDetailObj.email == "") {
            alert("Hãy nhập email!")
            return false
        }

        if (validateEmail(paramContactDetailObj.email) == false) {
            alert("Email chưa đúng định dạng!")
            return false
        }
        if (paramContactDetailObj.message.length < 20) {
            alert("Lời nhắn phải có hơn 20 ký tự!")
            return false
        }
        if (paramContactDetailObj.createDate == "") {
            alert("Hãy nhập ngày tạo liên hệ!")
            return false
        }
        return true

    }
    //hàm validate email:
    function validateEmail(paramEmail) {
        var vValidRegex = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        if (paramEmail.match(vValidRegex)) {
            return true
        } else {
            return false
        }
    }
    //b3: gọi api update contact:
    function callApiToUpdateDataContact(paramContactDetailObj, paramXmlHttpContactObj) {
        var vUrl = new URL(window.location.href)
        var vId = vUrl.searchParams.get("id");
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXmlHttpContactObj.open("PUT", vAPI_URL + vId, true);
        paramXmlHttpContactObj.setRequestHeader("Content-Type", "application/json");
        paramXmlHttpContactObj.send(JSON.stringify(paramContactDetailObj));
    }

</script>

</html>